//2010 0.1 Copyright (C) Michael Niedermayer 1998
#ifndef n2_all_h
#define n2_all_h

#define mabs(a) ((a)<0 ? -(a) : (a))
#define sign(a)   ((a)<0 ? -1 :  1)
#define is_neg(a) ((a)<0 ?  0 : -1)
#define is_pos(a) ((a)<0 ? -1 :  0)

#define u_char unsigned char
#define u_long unsigned long
#define u_short unsigned short
#define byte unsigned char
#define word unsigned short
#define dword unsigned long
#define ll long long

struct s_yuv{
  byte u, y1, v, y2;
};

struct s_rgb{
  byte b, g, r, x;
};

struct s_cl{
  byte chrom, lum;
};

union s_col{
  s_rgb rgb;
  s_yuv yuv;
  u_long a;
};

struct xxx{
  union{
    s_yuv *yuv;
    s_rgb *rgb;
    s_cl  *cl;
    byte  *b;
  };
  int phys;
};

class color{
 public:
   s_col c;
   color(void) { };
   void init(byte y, byte u, byte v, byte yuv_mode)
     { if(yuv_mode!=0){
         c.yuv.y1=c.yuv.y2=y;
         c.yuv.u=u;
         c.yuv.v=v;
       }else{
         c.rgb.r= (byte)( y + 1.375   *v); 
         c.rgb.g= (byte)( y - 0.703125*v - 0.34375*u); 
         c.rgb.b= (byte)( y + 1.734375*u);
       }
     };
} ;

#endif
