//2010 0.1 Copyright (C) Michael Niedermayer 1998

#include <stdio.h>
#include <time.h>
#include <string.h>
#include "2_all.h"
#include "2_grafix.h"
#include "2_gfunc.h"
#include "2_hw.h"
#include "2_menu.h"
#include "2_file.h"
#include "2_wins.h"
#include "2_crypt.h"

 extern int xres, yres, xresc;
 extern int buttons, xpos, ypos, lxpos, lypos;
 extern int fysize;
 extern byte font[4096];
 extern int me, mx, my;
 extern int grabf;
 extern xxx dispbuf, grab_dispbuf;
 extern menu menu_main[];
 extern int yuvmode;
 extern volatile int addr_errors, corr_errors;
 extern int single;
 int infox, infoy;
 int istate=1;
 int conty_b, conty_s, conty_c, contx_b, contx_s, contx_c;
 int cstate=1;

 long T1,T2,T3;

void draw_dispbuf(void){
 char textbuf[256];
 color c;

 T2=uclock();

 decrypt();

 if(istate==1){
   T1=uclock();
   sprintf(textbuf,"%f Decrypt", (float)(T1-T2)/UCLOCKS_PER_SEC);
   c.init(255, 0, 0, yuvmode);
   gprint(30, 30, c.c, textbuf);

   sprintf(textbuf,"%f Fps",1/((float)(T1-T3)/UCLOCKS_PER_SEC));
   c.init(255, 0, 0, yuvmode);
   gprint(50, 50, c.c, textbuf);

   sprintf(textbuf,"%d Corrupted Fields", corr_errors);
   c.init(255, 0, 0, yuvmode);
   gprint(60, 60, c.c, textbuf);

   sprintf(textbuf,"%d Address error's", addr_errors);
   c.init(255, 0, 0, yuvmode);
   gprint(70, 70, c.c, textbuf);

   T3=T2=T1;
 }

 if(grabf==1) grab(), grabf=0;

 if(me!=0) disp_menu(menu_main, mx+4, my+4, 0);   // +4 for mistakely menu hit

 if(me==0 && istate==1){
  // print info 

 }

 if(cstate==1) drawc();

 if(istate==1){
   T2=uclock();
   sprintf(textbuf,"%f Misc",(float)(T2-T1)/UCLOCKS_PER_SEC);
   c.init(255, 0, 0, yuvmode);
   gprint(40, 40, c.c, textbuf);
 }

 copy_vidbuffer();

}

