;2010 0.1 Copyright (C) Michael Niedermayer 1998

%include "2_all_a.asm"

segment .data

extern esp_save
extern _asm_temp
global _vc_corr__Fiiiiii

%define line1a       par1
%define line1b       par2
%define count1       par3
%define line2a       par4
%define line2b       par5
%define count2       par6

_vc_corr__Fiiiiii:
 push ebx

 push ecx
 push edx

 push esi
 push edi

 push ebp
 mov esi, [line1a]

 mov edi, [line1b]
 mov [esp_save], esp

 xor ecx, ecx
 mov esp, [count1]

 xor ebp, ebp
 xor edx, edx

 cmp esp, 4
  jb skip1

 mov eax, [esp + esi]
 mov ebx, [esp + edi]
 or eax, 0x80008000        

NoMMXloop:            
 sub edx, ecx                ; U
 sub eax, ebx                ;  V 1 
 and edx, 0x00FF00FF         ; U
 add ebp, edx                ;  V 1 
 mov ebx, eax                ; U
 and eax, 0xFF00FF00         ;  V 1
 shr eax, 8                  ; U
 mov ecx, [esp + esi + 4]    ;  V 1
 xor eax, 0x00800080         ; U
 or  ecx, 0x80008000         ;  V 1
 xor ebx, eax                ; U
 mov edx, [esp + edi + 4]    ;  V 1
 sub ebx, eax                ; U
 sub ecx, edx                ;  V 1
 and ebx, 0x00FF00FF         ; U
 mov edx, ecx                ;  V 1
 add ebp, ebx                ; U 
 and ecx, 0xFF00FF00         ;  V 1
 shr ecx, 8                  ; U
 mov eax, [esp + esi + 8]    ;  V 1
 xor ecx, 0x00800080         ; U
 or  eax, 0x80008000         ;  V 1
 xor edx, ecx                ; U
 mov ebx, [esp + edi + 8]    ;  V 1
 add esp, 8                  ; U
  jnc NoMMXloop              ;  V 1

skip1:

 mov esp, [esp_save]
 xor ecx, ecx

 mov esi, [line2a]           ; AGI
 mov edi, [line2b]

 mov esp, [count2]
 xor edx, edx

 cmp esp, 4
  jb skip2

 mov eax, [esp + esi]       
 mov ebx, [esp + edi]
 or eax, 0x80008000        

NoMMXloop2:
 sub edx, ecx                ; U
 sub eax, ebx                ;  V 1 
 and edx, 0x00FF00FF         ; U
 add ebp, edx                ;  V 1 
 mov ebx, eax                ; U
 and eax, 0xFF00FF00         ;  V 1
 shr eax, 8                  ; U
 mov ecx, [esp + esi + 4]    ;  V 1
 xor eax, 0x00800080         ; U
 or  ecx, 0x80008000         ;  V 1
 xor ebx, eax                ; U
 mov edx, [esp + edi + 4]    ;  V 1
 sub ebx, eax                ; U
 sub ecx, edx                ;  V 1
 and ebx, 0x00FF00FF         ; U
 mov edx, ecx                ;  V 1
 add ebp, ebx                ; U 
 and ecx, 0xFF00FF00         ;  V 1
 shr ecx, 8                  ; U
 mov eax, [esp + esi + 8]    ;  V 1
 xor ecx, 0x00800080         ; U
 or  eax, 0x80008000         ;  V 1
 xor edx, ecx                ; U
 mov ebx, [esp + edi + 8]    ;  V 1
 add esp, 8                  ; U
  jnc NoMMXloop2             ;  V 1

skip2:

 mov esp, [esp_save]
 mov eax, ebp                ;  

 shr eax, 16                 ;
 and ebp, 0x0000FFFF         ;

 add eax, ebp                ;
 pop ebp

 pop edi
 pop esi

 pop edx
 pop ecx

 pop ebx

ret




