//2010 0.1 Copyright (C) Michael Niedermayer 1998

#include <stdio.h>
#include <dos.h>
#include "2_all.h"
#include "2010.h"
#include "2_file.h"
#include "2_hw.h"

 extern int xres, yres, xress, yress;
 extern int fysize;
 extern byte font[4096];
 extern xxx dispbuf;
 extern int g_mode;
 extern int yuvmode;
 extern char *yuv2rgb_lut;

void grab(void){
 int i, j;
 FILE *fg;
 char grab_name[16];
 struct time ti;
 bmp bmpi;
 byte fwbuf[8];

 gettime(&ti);
 sprintf(grab_name, "G%02d%02d%02d.BMP", ti.ti_hour, ti.ti_min, ti.ti_sec);

 if((fg=fopen(grab_name, "ab"))==NULL && g_mode==0) error(FileWrite);

 bmpi.magic='B'+('M'<<8);
 bmpi.lenght=xress * yress * 3 + 54;
 bmpi.zero1=0;
 bmpi.datstart=54;
 bmpi.palstart=40; //??
 bmpi.xres=xress;
 bmpi.yres=yress;
 bmpi.planes=1;
 bmpi.bits=24;
 bmpi.comp=0;
 bmpi.size=xress * yress * 3;
 bmpi.xpel=0;
 bmpi.ypel=0;
 bmpi.clruse=0;
 bmpi.clrimp=0;

 fwrite(&bmpi, sizeof(bmpi), 1, fg);
 for(i=yress-1; i>=0; i--){
   for(j=0; j<xress; j++){
     if(yuvmode==0) fwrite((void*)(&dispbuf.rgb[j + i*xres]), 1, 3, fg);
     else {
       if(j>=xress>>1) break;

       mem2vid(fwbuf, dispbuf.yuv + j + (i*xres>>1), 2, 32);

       fwbuf[3]=fwbuf[4];
       fwbuf[4]=fwbuf[5];
       fwbuf[5]=fwbuf[6];

       fwrite(fwbuf, 1, 6, fg);
     }
   } 
 }

 fclose(fg);

}

long fsize(FILE *f){
 long i,j;
 i=ftell(f);                                  //get pos
 fseek(f,0,SEEK_END);                  //find end
 j=ftell(f);
 fseek(f,i,SEEK_SET);                         //restore pos
 return j;
}
