;2010 0.1 Copyright (C) Michael Niedermayer 1998

%include "2_all_a.asm"

segment .data

extern _mmx
extern esp_save   
extern _asm_temp  
extern _asm_temp2 
extern _asm_temp3 
extern _asm_temp4 

global _nagra_corr__Fiiiiiii

%define line2_end    par1
%define xress_check2 par2
%define linep        par3
%define linep2       par4
%define line2        par5
%define line_inf     par6
%define databuf      par7

_nagra_corr__Fiiiiiii:
; push eax
 push ebx

 push ecx
 push edx

 push esi
 push edi

 push ebp
 mov ebx, [line2]

loopi:

 mov [_asm_temp2], ebx
 mov ebp, [line_inf]

 shl ebx, 7
 mov edx, [xress_check2]

 add ebx, ebp
 mov ecx, [linep2]

 mov [_asm_temp3], ebx
 add ecx, edx

 mov ebx, [ebx + 112]
 mov [linep2], ecx

 mov esi, [databuf]
 test ebx, ebx

 mov edi, esi
  jz NEAR End

 add esi, edx
 add edi, edx

 add esi, ecx
 mov ecx, [linep]

 xor edx, -1
 add edi, ecx

 inc edx
 mov eax, [_mmx]

 mov [esp_save], esp
 mov esp, edx

 test eax, eax
  jz NoMMX

 movq mm3, [mmx_zero]

 movq mm0, [esp + esi]
 movq mm5, mm3

 movq mm1, [esp + edi]
 movq mm2, mm0

 movq mm6, [mmx_clip]

MMXloop:
 psubusb mm2, mm1            ; U
 psubusb mm1, mm0            ;  V 1
 movq mm0, [esp + esi + 8]   ; U
 por mm2, mm1                ;  V 1
 movq mm1, [esp + edi + 8]   ; U
 paddusb mm2, mm6            ;  V 1
 movq mm4, mm2               ; U
 punpcklbw mm2, mm3          ;  V 1
 punpckhbw mm4, mm3          ; U
 paddusw mm5, mm2            ;  V 1
 paddusw mm5, mm4            ; U
 movq mm2, mm0               ;  V 1
 add esp, 8                  ; U
  jnc MMXloop                ;  V 1

 movq mm0, mm5
 psrlq mm5, 32

 paddusw mm5, mm0

 movq mm0, mm5
 psrlq mm5, 16

 paddusw mm5, mm0

 movd ebp, mm5

 mov ebx, [_asm_temp]
 and ebp, 0xFFFF

 jmp EndMMX       
NoMMX:

 xor ebp, ebp           
 xor edx, edx           
 xor ecx, ecx           

 mov eax, [esp + esi]
 mov ebx, [esp + edi]
 or eax, 0x80008000        

NoMMXloop:            
 sub edx, ecx                ; U
 sub eax, ebx                ;  V 1 
 and edx, 0x00FF00FF         ; U
 add ebp, edx                ;  V 1 
 mov ebx, eax                ; U
 and eax, 0xFF00FF00         ;  V 1
 shr eax, 8                  ; U
 mov ecx, [esp + esi + 4]    ;  V 1
 xor eax, 0x00800080         ; U
 or  ecx, 0x80008000         ;  V 1
 xor ebx, eax                ; U
 mov edx, [esp + edi + 4]    ;  V 1
 sub ebx, eax                ; U
 sub ecx, edx                ;  V 1
 and ebx, 0x00FF00FF         ; U
 mov edx, ecx                ;  V 1
 add ebp, ebx                ; U 
 and ecx, 0xFF00FF00         ;  V 1
 shr ecx, 8                  ; U
 mov eax, [esp + esi + 8]    ;  V 1
 xor ecx, 0x00800080         ; U
 or  eax, 0x80008000         ;  V 1
 xor edx, ecx                ; U
 mov ebx, [esp + edi + 8]    ;  V 1
 add esp, 8                  ; U
  jnc NoMMXloop              ;  V 1


 mov ebx, [_asm_temp]        ; U    line_inf[line]
 mov eax, ebp                ;  V 1
 shr eax, 16                 ; U
 and ebp, 0x0000FFFF         ;  V 1
 add ebp, eax                ; U

EndMMX: 

 mov eax, [ebx + 108]        ; U | V 1
 cmp ebp, eax                ; U
  jg TryNext                 ;  V 1

 mov eax, [ebx + 84]         ; U 1
 cmp eax, ebp                ; U 
 mov esp, [_asm_temp2]       ;  V 1  line2
 sbb ecx, ecx                ; U 
 mov edx, 48                 ;  V 1
 and ecx, 32                 ; U 1

 mov eax, [ebx + ecx + 68]   ; U 2 AGI 
 cmp eax, ebp                ; U 1
 sbb esi, esi                ; U 1
 and esi, 16                 ; U 1
 or  ecx, esi                ; U 1

 mov eax, [ebx + ecx + 60]   ; U 2 AGI 
 cmp eax, ebp                ; U 1
 sbb esi, esi                ; U 1
 and esi, 8                  ; U 1
 or  ecx, esi                ; U 1

 mov eax, [ebx + ecx + 56]   ; U 2 AGI 
 cmp eax, ebp                ; U 1
 sbb esi, esi                ; U 1
 and esi, 4                  ; U 1
 or  ecx, esi                ; U 1

Copy1:  
 mov esi, [ebx + edx     ]    ; U
 mov edi, [ebx + edx + 56]    ;  V 1
 mov [ebx + edx + 4 ], esi    ; U
 mov [ebx + edx + 60], edi    ;  V 1
 sub edx, 4                   ; U
 cmp edx, ecx                 ;  V 1
  jge Copy1                   ; U  1
 mov [ebx + ecx     ], esp    ; U
 mov [ebx + ecx + 56], ebp    ;  V 1
    

TryNext:  
 

 mov ebx, [_asm_temp3]       ; U 1  line_inf[line2]

 mov eax, [ebx + 108]        ; U 2  AGI
 cmp ebp, eax                ; U
  jg End                     ;  V 1

 mov eax, [ebx + 84]         ; U 1
 cmp eax, ebp                ; U 
 mov esp, [_asm_temp4]       ;  V 1  line
 sbb ecx, ecx                ; U 
 mov edx, 48                 ;  V 1
 and ecx, 32                 ; U 1

 mov eax, [ebx + ecx + 68]   ; U 2 AGI 
 cmp eax, ebp                ; U 1
 sbb esi, esi                ; U 1
 and esi, 16                 ; U 1
 or  ecx, esi                ; U 1

 mov eax, [ebx + ecx + 60]   ; U 2 AGI 
 cmp eax, ebp                ; U 1
 sbb esi, esi                ; U 1
 and esi, 8                  ; U 1
 or  ecx, esi                ; U 1

 mov eax, [ebx + ecx + 56]   ; U 2 AGI 
 cmp eax, ebp                ; U 1
 sbb esi, esi                ; U 1
 and esi, 4                  ; U 1
 or  ecx, esi                ; U 1

Copy2:  
 mov esi, [ebx + edx     ]    ; U
 mov edi, [ebx + edx + 56]    ;  V 1
 mov [ebx + edx + 4 ], esi    ; U
 mov [ebx + edx + 60], edi    ;  V 1
 sub edx, 4                   ; U
 cmp edx, ecx                 ;  V 1
  jge Copy2                   ; U  1
 mov [ebx + ecx     ], esp    ; U
 mov [ebx + ecx + 56], ebp    ;  V 1
    

End:  
 
 mov esp, [esp_save]

 mov ebx, [line2]
 mov ecx, [line2_end]

 inc ebx

 cmp ebx, ecx
 mov [line2], ebx

  jl NEAR loopi


 pop ebp
 pop edi
 pop esi
 pop edx
 pop ecx
 pop ebx
; pop eax

ret

xyz times 8 dd 0

align8
mmx_zero times 2 dd 0
mmx_clip times 8 db 0
